Subject: Re: bug#37755: Logic in init_fringe_bitmap should be moved to backends (maybe rif->define_fringe_bitmap)

From: Eli Zaretskii <[email-masked]>
Date: Sat, 26 Oct 2019 19:03:24 +0300

> From: Carlos Pita <[email-masked]>
> Date: Sat, 26 Oct 2019 12:46:08 -0300
> Cc: [email-masked]
> 
>  Sorry, we cannot just ignore the dumping issue.  We don't want to
>  waste CPU cycles each startup to regenerate these standard bitmaps.
>  So the fringe bit patterns need to be initialized at dump time and
>  dumped together with all the other stuff we prepare at that time.
> 
> Ok, I'm not sure about how dumping works, but the patterns that you store are backend specific. Does the
> dumper take that into account?

The pdump file, like the Emacs binary, is architecture-specific.  So
yes, this is inherently taken into account.

>  Does this proposal resolve the difficulty?  If not, please point out
>  what else is missing.
> 
> I just thought that the change decoupled and simplified the code, but I can always add an initialization step to
> the rif, previous to the definition of the actual bitmaps used by the backend.

I don't think you can do that with a RIF, for the reason already
mentioned: Emacs is dumped in batch mode, where we have a frame type
that doesn't support fringes, and doesn't implement the RIF interfaces
you will need.